#pragma once

//---------------------------------------------------------------------------
//
//	DIBSection̊ǗNX
//
//---------------------------------------------------------------------------
class CDIBitmap
{
private:
	int		Width;
	int		Height;
	DWORD	Length;
	DWORD*	Pixels;
	
	BITMAPINFO	biBMP;
	HBITMAP		hbmpBMP;
	HBITMAP		hbmpOld;
	HDC			hdcBMP;

public:
	//RXgN^ƃfXgN^
	CDIBitmap();
	CDIBitmap( int w, int h ) { SetSize(w, h); }
	virtual ~CDIBitmap();


	//GDI\bh
	HDC GetDC(HWND wnd);
	void ReleaseDC();


	//X^Iy[V
	void StretchBlt(HDC hdest, int x, int y, DWORD dwRop);
	void Draw(int x, int y, CDIBitmap* src);
	void Clear(DWORD color);


	//ANZX\bh
	void SetSize( int w, int h );
	int GetWidth() const { return Width; }
	int GetHeight() const { return Height; }
	DWORD GetLength() const { return Length; }

	DWORD* GetBits() { return Pixels; }
	const DWORD* GetBits() const { return Pixels; }
	
	HBITMAP GetHandle() { return hbmpBMP; }
	const BITMAPINFO* GetBmpInfo() const { return &biBMP; }


	//t@CIy[V
	void SaveToFile( tstring path );
};
