#pragma once

//---------------------------------------------------------------------------
//
//	AvP[VǗNX
//
//---------------------------------------------------------------------------

// Rg[XVʎq
const DWORD CTRL_SMITHCHART	= 1<<0;
const DWORD CTRL_DESIGNLIST	= 1<<1;
const DWORD CTRL_MATCHLIST	= 1<<2;
const DWORD CTRL_SWEEPLIST	= 1<<3;
const DWORD CTRL_MARKERLIST	= 1<<4;

class CMainFrame;
class CMelonDocument;
class CMelonDesign;
class IParamInterface;
class CBasicSmithStyle;
class CMelonManager
{
private:
	// CEChEIuWFNg
	CMainFrame&			mMainFrame;

	// hLg
	CMelonDocument*		pDocument;

	// `X^C
	CBasicSmithStyle*	mSmithStyle;

	// ĕ`v
	bool	mRedraw;

	void drawSmithWindow();

public:
	// RXgN^ƃfXgN^
	CMelonManager(CMainFrame& frm);
	virtual ~CMelonManager();

	// AChCxgnh
	void OnIdle();

	// hLgEfUC̓o
	void SetDocument(CMelonDocument* doc);
	CMelonDocument* GetDocument() { return pDocument; }
	CMelonDesign* GetDesign(unsigned int index);
	CMelonDesign* GetDesign();

	// p[^̓o
	CBasicSmithStyle* GetStyle()	{ return mSmithStyle; }

	// AvP[VƃhLg̒
	void UpdateControl(DWORD id);
	void UpdateSmithChart();
	void UpdateDesignList();
	void UpdateMatchList();
	void UpdateSweepList();
	void UpdateMarkerList();
	void UpdatePropList(IParamInterface* item);

	void DrawSmithChart(Gdiplus::Graphics& g);
};

//---------------------------------------------------------------------------
//
//	ǗNXANZX
//
//---------------------------------------------------------------------------
class CManagerAccess
{
private:
	static CMelonManager* pManager;

public:
	// RXgN^AfXgN^
	CManagerAccess(){}
	virtual ~CManagerAccess(){}

	// ANZX\bh
	static void SetManager(CMelonManager* mgr);
	static CMelonManager* GetManager() { return pManager; }
};
