#pragma once
#include "stdafx.h"
#include "MelonManager.h"
#include "ListViewPlus.h"

//---------------------------------------------------------------------------
//
//	Hp̃Xgr[
//
//---------------------------------------------------------------------------
#define EDIT_TEXTBOX	0
#define EDIT_COMPLIST	1
#define EDIT_DESCLIST	2
#define EDIT_COLORDLG	3
class CMelonDesign;
class CMatchListView :
	public CListViewPlus<CBasicListItem3>,
	public CManagerAccess
{
private:
	// uNpACe
	CBasicListItem3		mBlankItem;

public:
	DECLARE_WND_SUPERCLASS(NULL, CListViewPlus::GetWndClassName())

	// WTL bZ[W}bv
	BEGIN_MSG_MAP(CMatchListView)
		MSG_WM_KEYDOWN(OnKeyDown)
		MSG_WM_LBUTTONDOWN(OnLButtonDown)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnItemChanged)
		CHAIN_MSG_MAP(CListViewPlus<CBasicListItem3>)
	END_MSG_MAP()

	// RXgN^ƃfXgN^
	CMatchListView();
	~CMatchListView(){}

	// hbOhbvCxg
	void EndItemDrop(int dest, int item);
	
	// ACeҏWCxg
	void EndItemEdit(int item, int sub_item);

	// fUC琮HXg𐶐
	void SetDesign(CMelonDesign* design);
	
	// ACeICxg
	LRESULT OnItemChanged(LPNMHDR pnmh);
	
	// L[_ECxg
	void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	void OnLButtonDown(UINT nFlags, CPoint point);
};

//---------------------------------------------------------------------------
//
//	gW̃Xgr[
//
//---------------------------------------------------------------------------
class CSweepListView :
	public CListViewPlus<CBasicListItem4>,
	public CManagerAccess
{
private:
	// uNpACe
	CBasicListItem4		mBlankItem;

public:
	DECLARE_WND_SUPERCLASS(NULL, CListViewPlus::GetWndClassName())

	// WTL bZ[W}bv
	BEGIN_MSG_MAP(CSweepListView)
		MSG_WM_KEYDOWN(OnKeyDown)
		MSG_WM_LBUTTONDOWN(OnLButtonDown)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnItemChanged)
		CHAIN_MSG_MAP(CListViewPlus<CBasicListItem4>)
	END_MSG_MAP()

	// RXgN^ƃfXgN^
	CSweepListView();
	~CSweepListView(){}

	// fUCgW̃Xg쐬
	void SetDesign(CMelonDesign* design);

	// ACeҏWCxg
	void EndItemEdit(int item, int sub_item);
	
	// ACeICxg
	LRESULT OnItemChanged(LPNMHDR pnmh);
	
	// L[_ECxg
	void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	void OnLButtonDown(UINT nFlags, CPoint point);
};

//---------------------------------------------------------------------------
//
//	f[^}[J[Xgr[
//
//---------------------------------------------------------------------------
class CMarkerListView :
	public CListViewPlus<CBasicListItem3>,
	public CManagerAccess
{
private:
	// uNpACe
	CBasicListItem3		mBlankItem;

public:
	DECLARE_WND_SUPERCLASS(NULL, CListViewPlus::GetWndClassName())

	// WTL bZ[W}bv
	BEGIN_MSG_MAP(CMarkerListView)
		MSG_WM_KEYDOWN(OnKeyDown)
		MSG_WM_LBUTTONDOWN(OnLButtonDown)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnItemChanged)
		CHAIN_MSG_MAP(CListViewPlus<CBasicListItem3>)
	END_MSG_MAP()

	// RXgN^ƃfXgN^
	CMarkerListView();
	~CMarkerListView(){}

	// fUCgW̃Xg쐬
	void SetDesign(CMelonDesign* design);

	// ACeҏWCxg
	void EndItemEdit(int item, int sub_item);
	
	// ACeICxg
	LRESULT OnItemChanged(LPNMHDR pnmh);

	// L[_ECxg
	void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	void OnLButtonDown(UINT nFlags, CPoint point);
};

//---------------------------------------------------------------------------
//
//	vpeBXgr[
//
//---------------------------------------------------------------------------
class IParamInterface;
class CPropListView :
	public CListViewPlus<CBasicListItem3>,
	public CCustomDraw<CPropListView>,
	public CManagerAccess
{
private:
	IParamInterface*	mItem;

public:
	DECLARE_WND_SUPERCLASS(NULL, CListViewPlus::GetWndClassName())
	
	BEGIN_MSG_MAP(CPropListView)
		CHAIN_MSG_MAP_ALT(CCustomDraw<CPropListView>, 1)
		CHAIN_MSG_MAP(CListViewPlus<CBasicListItem3>)
	END_MSG_MAP()

	// RXgN^ƃfXgN^
	CPropListView(){}
	~CPropListView(){}

	// ep[^ƃN
	void SetProperties(IParamInterface* item);

	// ACeҏW
	void EndItemEdit(int item, int sub_item);

	// JX^h[
	DWORD OnPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
	DWORD OnItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
	DWORD OnSubItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
};

//---------------------------------------------------------------------------
//
//	FI_CAO
//
//---------------------------------------------------------------------------
class CColorEdit : public CItemEditor
{
private:
	HWND	mEditorParent;
	DWORD	mColor;

public:
	int GetItemText(WTL::CString& strText) const;
	void BeginItemEdit(const CRect& rect, LPCTSTR strText, int image=-1);
	HWND InitItemEdit(HWND hWndParent);
	operator HWND() const { return reinterpret_cast<HWND>(INVALID_HANDLE_VALUE); }
};
