#pragma once

//---------------------------------------------------------------------------
//
//	p[^C^[tFCX
//
//---------------------------------------------------------------------------
class IListItem;
class CMelonUnits;
class IParamInterface
{
protected:
	// eRo[^
	bool GetVariable(IListItem& item, bool& var);
	void SetItem(IListItem& item, bool var);

	bool GetVariable(IListItem& item, float& var);
	bool GetVariable(IListItem& item, double& var);
	void SetItem(IListItem& item, double var);

	bool GetVariable(IListItem& item, Gdiplus::Color& color);
	void SetItem(IListItem& item, const Gdiplus::Color& color);

	bool GetVariable(IListItem& item, double& var, CMelonUnits& unit);
	void SetItem(IListItem& item, double var, const CMelonUnits& unit, LPCTSTR ext);

public:
	// RXgN^ƃfXgN^
	IParamInterface(){}
	virtual ~IParamInterface(){}
	
	// p[^̓o
	virtual void SetParam(IListItem& item) {}
	virtual void GetParam(IListItem& item) {}

	// vpeB̓o
	virtual void SetProperty(int index, IListItem& item) {}
	virtual void GetProperty(int index, IListItem& item) {}

	// vpeB̐
	virtual int NumProperties() const { return 0; }
};
