#pragma once
#include "resource.h"
#include "DIBitmap.h"
#include "MelonManager.h"

//---------------------------------------------------------------------------
//
//	X~X`[gEChENX
//
//---------------------------------------------------------------------------
class CDrawStyle;
class CSmithWindow :
	public CWindowImpl<CSmithWindow>,
	public CMessageFilter,
	public CManagerAccess
{
private:
	// obNobt@
	CDIBitmap		mCanvas;

	// Wϊs
	Gdiplus::Matrix*	mTransform;

public:
	DECLARE_WND_CLASS_EX(NULL, CS_HREDRAW|CS_VREDRAW, NULL)

	// bZ[W}bv
	BEGIN_MSG_MAP(CMainFrame)
		MSG_WM_ERASEBKGND(OnEraseBkgnd)
		MSG_WM_PAINT(OnPaint)
		MSG_WM_SIZE(OnSize)
		MSG_WM_DROPFILES(OnDropFiles)
		MSG_WM_CREATE(OnCreate)
        MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()
	
	// eCxgnh
	BOOL PreTranslateMessage(MSG *pMsg);
	int OnCreate(LPCREATESTRUCT lpCreateStruct);
	void OnDestroy();
	void OnSize(UINT nType, CSize size);
	void OnPaint(CDCHandle /*dc*/);
	BOOL OnEraseBkgnd(CDCHandle dc) { return TRUE; }
	void OnDropFiles(HDROP hDropInfo);

	// ANZX\bh
	CDIBitmap* GetCanvas()	{ return &mCanvas; }
	const Gdiplus::Matrix* GetTransform() const	{ return mTransform; }
};

