#pragma once


//]uȍsԂ܂
template<class _T>
void conj_matrix(_T& matrix)
{
	for ( unsigned int i=0; i<matrix.size1(); i++ ) {
		for ( unsigned int k=0; k<matrix.size2(); k++ ) {

			matrix(i, k) = conj( matrix(i, k) );
		}
	}
	matrix = trans(matrix);
}

//tsvZ܂
template<class _T>
void inverse_matrix(_T& matrix)
{
	typedef ublas::matrix< complex<double> > complex_matrix;

	//Pʍs
	complex_matrix res = ublas::identity_matrix< complex<double> >(matrix.size1());

	//
	ublas::permutation_matrix<> pm(matrix.size1());

	//LUAOiƌޑ
	ublas::lu_factorize(matrix, pm);
	ublas::lu_substitute(matrix, pm, res);

	matrix = res;
}

//|[gւsɃANZX܂
template<class _T>
class basic_swap_matrix
{
public:
	typedef unsigned int	size_type;
private:

	size_type	mSize;

	ublas::vector<size_type>	mIndex;

public:
	//RXgN^
	basic_swap_matrix(size_type size=2)
		: mIndex(size)
	{
		mSize = size;
		for ( size_type i=0; i<size; i++ ) mIndex[i] = i;
	}

	//vfւsԂ܂
	_T operator()(const _T& matrix) const
	{
		_T res;
		res.resize(mSize, mSize);

		for ( size_type i=0; i<mSize; i++ ) {
			for ( size_type j=0; j<mSize; j++ ) {
				res(i, j) = matrix(mIndex(i), mIndex(j));
			}
		}
		
		return res;
	}

	//ւ̐ݒ܂
	size_type& operator[](size_type i) { return mIndex[i]; }
	const size_type& operator[](size_type i) const { return mIndex[i]; }

	//ANZX\bh
	size_type size() const { return mSize; }
	void size( unsigned int sz )
	{
		mSize = sz;
		mIndex.resize(sz);
		for ( size_type i=0; i<size; i++ ) mIndex[i] = i;
	}
};

typedef basic_swap_matrix<complex_matrix> swap_matrix;