#include "stdafx.h"
#include "SmithChart.h"
#include "MelonDocument.h"

// hLgX~X`[gɕ`悵܂
void CMelonDocument::Draw(CSmithChart& chart)
{
	// ŏɃX~X`[g`悵܂
	design_iterator it;
	for ( it=mDesignList.begin(); it!=mDesignList.end(); it++ )
		(*it)->Draw(chart);
	
	// }[J[͌ォ`悵܂
	for ( it=mDesignList.begin(); it!=mDesignList.end(); it++ )
		(*it)->DrawMarker(chart);
}
//---------------------------------------------------------------------------

// fUC̒ǉ
void CMelonDocument::AddDesign(CMelonDesign* design)
{
	mDesignList.push_back(design);
	ActivateDesign(mDesignList.size() - 1);
}
//---------------------------------------------------------------------------

// fUC̒ǉ
void CMelonDocument::AddDesign(CMatchingElem* term)
{
	mDesignList.push_back( new CMelonDesign(term) );
	ActivateDesign(mDesignList.size() - 1);
}
//---------------------------------------------------------------------------

// fUC̍폜
void CMelonDocument::DelDesign(size_type index)
{
	if ( index>=mDesignList.size() ) return;
	delete mDesignList[index];
	mDesignList.erase(mDesignList.begin() + index);
	ActivateDesign(mDesignList.size() - 1);
}
//---------------------------------------------------------------------------

// fUC̑S폜
void CMelonDocument::Clear()
{
	size_type i;
	for ( i=0; i<mDesignList.size(); i++ )
		delete mDesignList[i];

	mDesignList.clear();
	mActiveDesign = NULL;
}
//---------------------------------------------------------------------------

// w肵fUCANeBuɂ܂
void CMelonDocument::ActivateDesign(size_type index)
{
	size_type i;
	
	mActiveDesign = NULL;
	if ( index<mDesignList.size() ) {
		for ( i=0; i<mDesignList.size(); i++ ) {
			
			if ( i==index ) {
				mDesignList[i]->SetStatus(DESIGN_ACTIVE);
				mActiveDesign = mDesignList[i];
			}
			else
				mDesignList[i]->ClrStatus(DESIGN_ACTIVE);
		}

		mActiveIndex = index;
	}
}
//---------------------------------------------------------------------------

// RXgN^
CMelonDocument::CMelonDocument()
{
	mActiveDesign = NULL;
	mActiveIndex = -1;
}
//---------------------------------------------------------------------------

// fXgN^
CMelonDocument::~CMelonDocument()
{
	Clear();
}
//---------------------------------------------------------------------------
