#include "stdafx.h"
#include "ParamInterface.h"
#include "MelonUnits.h"
#include "ListItem.h"
#include "MyListView.h"
#include <boost/algorithm/string.hpp>

// l擾܂
bool IParamInterface::GetVariable(IListItem& item, bool& var)
{
	tistringstream is( item.GetText(1) );
	is >> var;
	return !is.fail();
}
//---------------------------------------------------------------------------

// XgACeɐlݒ肵܂
void IParamInterface::SetItem(IListItem& item, bool var)
{
	tostringstream os;
	os << var;
	item.SetText(1, os.str().c_str());
	item.SetText(2, _T(""));
	
	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_DISABLED);
}
//---------------------------------------------------------------------------

// l擾܂
bool IParamInterface::GetVariable(IListItem& item, float& var)
{
	tistringstream is( item.GetText(1) );
	is >> var;
	return !is.fail();
}
//---------------------------------------------------------------------------
bool IParamInterface::GetVariable(IListItem& item, double& var)
{
	tistringstream is( item.GetText(1) );
	is >> var;
	return !is.fail();
}
//---------------------------------------------------------------------------

// XgACeɐlݒ肵܂
void IParamInterface::SetItem(IListItem& item, double var)
{
	tostringstream os;
	os << var;
	item.SetText(1, os.str().c_str());
	item.SetText(2, _T(""));
	
	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_DISABLED);
}
//---------------------------------------------------------------------------

// F擾܂
bool IParamInterface::GetVariable(IListItem& item, Gdiplus::Color& color)
{
	DWORD ref;
	tistringstream is( item.GetText(1) );
	
	is >> std::hex >> ref;
	if ( !is.fail() )
		color.SetFromCOLORREF(ref);

	return !is.fail();
}
//---------------------------------------------------------------------------

// XgACeɐFݒ肵܂
void IParamInterface::SetItem(IListItem& item, const Gdiplus::Color& color)
{
	tostringstream os;
	os << std::hex << std::showbase << color.ToCOLORREF();
	item.SetText(1, os.str().c_str());
	item.SetText(2, _T(""));

	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_COLORDLG);
	item.SetEditType(2, EDIT_DISABLED);
}
//---------------------------------------------------------------------------

// PʕtŐl擾܂
bool IParamInterface::GetVariable(IListItem& item, double& var, CMelonUnits& unit)
{
	double d;
	tistringstream is( item.GetText(1) );
	tstring buff;

	is >> d;
	if ( !is.fail() ) {

		is >> buff;
		boost::algorithm::trim(buff);
		
		// PʂlɋLqĂ΁APʍXV
		if ( !buff.empty() )
			unit.SetUnit( buff.c_str() );

		// PʂLqĂȂ΁AZgp
		else
			unit.SetUnit( item.GetText(2) );
		
		// gXV
		var = d * unit.GetUnit();
	}

	return !is.fail();
}
//---------------------------------------------------------------------------

// XgACeɒPʕtŐlݒ肵܂
void IParamInterface::SetItem(IListItem& item, double var, const CMelonUnits& unit, LPCTSTR ext)
{
	tostringstream os;
	os << unit( var );
	item.SetText(1, os.str().c_str());
	
	os.str(_T(""));
	os << unit.GetInitial() << ext;
	item.SetText(2, os.str().c_str());
	
	item.SetEditType(0, EDIT_DISABLED);
	item.SetEditType(1, EDIT_TEXTBOX);
	item.SetEditType(2, EDIT_TEXTBOX);
}
//---------------------------------------------------------------------------
