#pragma once
#include "resource.h"
#include "MyListView.h"
#include "MelonManager.h"

//---------------------------------------------------------------------------
//
//	vpeBtH[r[
//
//---------------------------------------------------------------------------
class CMelonDocument;
class CPropertyForm :
	public CDialogImpl<CPropertyForm>,
	public CDialogResize<CPropertyForm>,
	public CMessageFilter,
	public CManagerAccess
{
private:
	void initPropertyList();

public:
	enum { IDD = IDD_PROPFORM };

	// eRg[
	CComboBoxEx		mDesignList;
	CPropListView	mPropertyList;
    
	// WTL TCY}bv
	BEGIN_DLGRESIZE_MAP(CPropertyForm)
		DLGRESIZE_CONTROL(IDC_DESIGNLIST, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_PROPLIST, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	// WTL̃bZ[W}bv
    BEGIN_MSG_MAP(CPropertyForm)
		MSG_WM_INITDIALOG(OnInitDialog)
        MSG_WM_DESTROY(OnDestroy)
		COMMAND_HANDLER_EX(IDC_DESIGNLIST, CBN_SELCHANGE, OnSelChange)
		CHAIN_MSG_MAP(CDialogResize<CPropertyForm>)
		REFLECT_NOTIFICATIONS_HWND_FILTERED(mPropertyList)
    END_MSG_MAP()


	// eCxgnh
	BOOL PreTranslateMessage(MSG *pMsg);
	BOOL OnInitDialog(CWindow wndFocus, LPARAM lInitParam);
    void OnDestroy();
	void SetDocument(CMelonDocument* doc);
	void OnSelChange(UINT uNotifyCode, int nID, CWindow wndCtl);
};
