// SampleProject.cpp
#include "stdafx.h"
#include "MainForm.h"

//GDI+̃N
#pragma comment(lib, "gdiplus.lib")

//ATL/WTLCX^X
CAppModule _Module;

//Gg[|Cg
int APIENTRY _tWinMain(HINSTANCE hInstance, 
                       HINSTANCE hPrevInstance, 
                       LPTSTR    lpCmdLine, 
                       int       nCmdShow)
{
	std::locale::global( std::locale("") );

	// GDI+̏
    ULONG_PTR gdiplusToken;
    Gdiplus::GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::GdiplusStartup( &gdiplusToken, &gdiplusStartupInput, NULL );

	// Rg[̏
	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));
	::DefWindowProc(NULL, 0, 0, 0L);
	AtlInitCommonControls(ICC_WIN95_CLASSES|ICC_USEREX_CLASSES);

	// bZ[W[v쐬
	CMessageLoop theLoop;
	_Module.Init(NULL, hInstance);
	_Module.AddMessageLoop(&theLoop);


	// AvP[VǗNX̐ݒ
    CMainFrame wnd;
	CMelonManager* mgr = new CMelonManager(wnd);
	CManagerAccess::SetManager(mgr);

	// EChE쐬āAvOJn
	wnd.CreateEx(NULL, CRect(100, 100, 740, 480));
	wnd.ShowWindow(nCmdShow);
	int nRet = theLoop.Run();

	// I
	_Module.RemoveMessageLoop();
	_Module.Term();
	::CoUninitialize();
	delete mgr;

	// GDIPLUS̊J
    Gdiplus::GdiplusShutdown( gdiplusToken );

    return nRet;
}